<?php

namespace Drupal\elb;

use Drupal\Core\Config\ConfigFactory;
/**
 * Class BlacklistService.
 */
class BlacklistService {

  /**
   * The blacklist.
   * @var [] string
   */
  protected $blacklist;

  /**
   * The Config Factory service.
   * @var \Drupal\Core\Config\ConfigFactory
   */
  protected $config_factory;

  /**
   * Constructs a new BlacklistService object.
   * @param \Drupal\Core\Config\ConfigFactory $config_factory
   *   The config factory.
   */
  function __construct(\Drupal\Core\Config\ConfigFactory $config_factory) {
    $this->config_factory = $config_factory;
    $this->blacklist = $this->get();
  }

  /**
   * Return the blacklist.
   * @return [] string
   */
  public function get() {
    $blacklist = $this->config_factory->get('elb.settings')->get('blacklist');
    $backlist_array = explode(',', $blacklist);
    return array_map('trim', $backlist_array);
  }

  /**
   * Checks if the given $uri is blacklisted.
   */
  public function isBlacklisted($uri) {
    foreach ($this->blacklist as $prohibited_string) {
      if (substr_count($uri, $prohibited_string)) {
        return TRUE;
      }
    }
    return FALSE;
  }
}
