<?php

namespace Drupal\elb\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class ExtLinkBlacklistSettingsForm.
 */
class ExtLinkBlacklistSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'elb.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ext_link_blacklist_settings_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('elb.settings');
    $form['blacklist'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Blacklist'),
      '#description' => $this->t('A list of patterns, separated by comma (ie &quot;domain.com, domain.net&quot;).'),
      '#default_value' => $config->get('blacklist'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);

    $this->config('elb.settings')
      ->set('blacklist', $form_state->getValue('blacklist'))
      ->save();
  }

}
