<?php

namespace Drupal\elb\Plugin\Field\FieldWidget;

use Drupal\link\Plugin\Field\FieldWidget\LinkWidget;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'ext_link_blacklist_field_widget' widget.
 *
 * @FieldWidget(
 *   id = "ext_link_blacklist_widget",
 *   module = "elb",
 *   label = @Translation("External link blacklist"),
 *   field_types = {
 *     "link"
 *   }
 * )
 */
class ExtLinkBlacklistWidget extends LinkWidget {

  /**
   * Checks the uri against the blacklist.
   */
  public static function validateUriElement($element, FormStateInterface $form_state, $form) {
    $uri = static::getUserEnteredStringAsUri($element['#value']);
    parent::validateUriElement($element, $form_state, $form);
    if ($form_state->getErrors()) {
      // If there are already errors, continue.
      return;
    }
    $blacklist = \Drupal::service('elb.blacklist')->get();
    // if (substr_count($uri, 'google')) {
    if (\Drupal::service('elb.blacklist')->isBlacklisted($uri)) {
      $form_state->setError($element, t('This URL contains a pattern that is blacklisted.'));
      return;
    }
  }
}
